<?php
/**
* 2007-2015 Apollotheme
*
* NOTICE OF LICENSE
*
* ApPageBuilder is module help you can build content for your shop
*
* DISCLAIMER
*
*  @Module Name: AP Page Builder
*  @author    Apollotheme <apollotheme@gmail.com>
*  @copyright 2007-2015 Apollotheme
*  @license   http://apollotheme.com - prestashop template provider
*/

require_once(_PS_MODULE_DIR_.'appagebuilder/classes/shortcodes.php');
require_once(_PS_MODULE_DIR_.'appagebuilder/classes/ApPageSetting.php');
class ApPageBuilderProfilesModel extends ObjectModel
{
	public $name;
	public $params;
	public $page;
	public $profile_key;
	public $header;
	public $content;
	public $footer;
	public $product;
	public $active;
	/**
	 * @see ObjectModel::$definition
	 */
	public static $definition = array(
		'table' => 'appagebuilder_profiles',
		'primary' => 'id_appagebuilder_profiles',
		'multilang' => false,
		'fields' => array(
			'name' => array('type' => self::TYPE_STRING, 'validate' => 'isString', 'size' => 255),
			'page' => array('type' => self::TYPE_STRING, 'validate' => 'isString', 'size' => 255),
			'profile_key' => array('type' => self::TYPE_STRING, 'validate' => 'isString', 'size' => 255),
			'header' => array('type' => self::TYPE_INT, 'validate' => 'isUnsignedId'),
			'content' => array('type' => self::TYPE_INT, 'validate' => 'isUnsignedId'),
			'footer' => array('type' => self::TYPE_INT, 'validate' => 'isUnsignedId'),
			'product' => array('type' => self::TYPE_INT, 'validate' => 'isUnsignedId'),
                        'active' => array('type' => self::TYPE_BOOL, 'shop' => true, 'validate' => 'isBool'),
			'params' => array('type' => self::TYPE_HTML)
		)
	);
	public	function __construct($id = null, $id_lang = null, $id_shop = null, Context $context = null)
	{
		parent::__construct($id, $id_lang, $id_shop);
	}
	public function toggleStatus()
	{
		//can not de-active, the profile is active
		if ($this->active)
			return false;
		else
		{   
                    $this->deActiveAll($this->page);
                    return true;
		}
	}
	public function deActiveAll($page)
	{
		$context = Context::getContext();
		$id_shop = $context->shop->id;
		//$where = ' WHERE ps.id_shop='.$id_shop." AND ps.id_appagebuilder_profiles != '".(int)$this->id."'";
                $where = ' WHERE ps.id_shop='.(int)$id_shop;
		Db::getInstance()->execute('UPDATE `'._DB_PREFIX_.'appagebuilder_profiles_shop` ps set ps.active = 0 '.$where);
                $where = ' WHERE ps.id_shop='.$id_shop." AND ps.id_appagebuilder_profiles = '".(int)$this->id."'";
                Db::getInstance()->execute('UPDATE `'._DB_PREFIX_.'appagebuilder_profiles_shop` ps set ps.active = 1 '.$where);
	}
	public function getAllProfileByShop()
	{
		$context = Context::getContext();
		$id_shop = $context->shop->id;
		$where = ' WHERE id_shop="'.$id_shop.'"';
		$sql = 'SELECT p.*, ps.*
			 FROM '._DB_PREFIX_.'appagebuilder_profiles p 
			 INNER JOIN '._DB_PREFIX_.'appagebuilder_profiles_shop ps ON (ps.id_appagebuilder_profiles = p.id_appagebuilder_profiles)'
			.$where;
		return Db::getInstance()->executes($sql);
	}
	public function add($autodate = true, $null_values = false)
	{
		$context = Context::getContext();
		$id_shop = $context->shop->id;
		$res = parent::add($autodate, $null_values);
		$res &= Db::getInstance()->execute('
				INSERT INTO `'._DB_PREFIX_.'appagebuilder_profiles_shop` (`id_shop`, `id_appagebuilder_profiles`)
				VALUES('.(int)$id_shop.', '.(int)$this->id.')'
		);
                if(Db::getInstance()->getValue('SELECT COUNT(p.`id_appagebuilder_profiles`) AS total FROM `'._DB_PREFIX_.'appagebuilder_profiles` p INNER JOIN `'._DB_PREFIX_.'appagebuilder_profiles_shop` ps ON(p.id_appagebuilder_profiles = ps.id_appagebuilder_profiles) WHERE id_shop='.$id_shop) <=1)
                    $this->deActiveAll($this->page);
                
		return $res;
	}
	public function update($null_values = false)
	{
		if ($this->active)
			$this->deActiveAll($this->page);
                
                parent::update();
                
		return parent::update();
	}
	public function getProfilesInPage($id = 0)
	{
		$context = Context::getContext();
		$id_shop = $context->shop->id;
		$where = ' WHERE ps.id_shop='.$id_shop." AND p.page='".$this->page."'";
		if ($id)
			$where .= ' AND p.id_appagebuilder_profiles !='.(int)$id;
		$inner_join = 'INNER JOIN `'._DB_PREFIX_.'appagebuilder_profiles_shop` ps ON (ps.id_appagebuilder_profiles = p.id_appagebuilder_profiles)';
		$sql = 'SELECT p.* from `'._DB_PREFIX_.'appagebuilder_profiles` p '.$inner_join.$where;
		return Db::getInstance()->executes($sql);
	}
	public static function getActiveProfile($page)
	{
		$result = null;
		try
		{
			$context = Context::getContext();
			$id_shop = $context->shop->id;
			$id_profile = Tools::getIsset('id_appagebuilder_profiles') ? Tools::getValue('id_appagebuilder_profiles') : '';
			if ($id_profile)
				$where = ' WHERE ps.id_shop='.$id_shop.' AND p.id_appagebuilder_profiles='.(int)$id_profile;
			else
				$where = ' WHERE ps.id_shop='.$id_shop.' AND active=1 ';
			$inner_join = 'INNER JOIN `'._DB_PREFIX_.'appagebuilder_profiles_shop` ps ON (ps.id_appagebuilder_profiles = p.id_appagebuilder_profiles)';
			$sql = 'SELECT p.* from `'._DB_PREFIX_.'appagebuilder_profiles` p '.$inner_join.$where;
			$result = Db::getInstance()->getRow($sql);
		}
		catch (Exception $ex)
		{
			$result = null;
		}
		return $result;
	}
	public function getProfile($id)
	{
		$new_id = 0;
		$sql = 'SELECT * FROM `'._DB_PREFIX_.'appagebuilder_profiles` WHERE id_appagebuilder_profiles='.$id;
		$object = Db::getInstance()->getRow($sql);
		return $object ? $object : null;
	}
	public function duplicateProfile($id, $name, $profile_key, $id_shop)
	{
		$new_id = 0;
		$sql = 'SELECT * FROM `'._DB_PREFIX_.'appagebuilder_profiles` WHERE id_appagebuilder_profiles='.$id;
		$object_duplicated = Db::getInstance()->getRow($sql);
		if ($object_duplicated)
		{
			$sql = 'INSERT INTO `'._DB_PREFIX_.'appagebuilder_profiles`(name, profile_key, page, active) VALUES("'
					.$name.$object_duplicated['name'].'", "'.$profile_key.'", "index", 0)';
			Db::getInstance()->execute($sql);
			$new_id = Db::getInstance()->Insert_ID();
			$sql = 'INSERT INTO `'._DB_PREFIX_.'appagebuilder_profiles_shop`(id_appagebuilder_profiles, id_shop) VALUES('
					.$new_id.', '.$id_shop.')';
			Db::getInstance()->execute($sql);
			return $new_id;
		}
		return 0;
	}
	public function customDuplicateObject($message)
	{
		$object_duplicated = parent::duplicateObject();
		$object_duplicated->active = 0;
		$object_duplicated->name = $message.' '.$object_duplicated->name;
		return $object_duplicated;
	}
	public function save($null_values = false, $autodate = true)
	{
		$context = Context::getContext();
		$this->id_shop = $context->shop->id;
		if ($this->active)
			$this->deActiveAll($this->page);
		return parent::save();
	}
	public static function deleteById($id)
	{
		$id = (int)$id;
		$sql = 'SELECT * FROM `'._DB_PREFIX_.'appagebuilder_profiles` WHERE id_appagebuilder_profiles='.$id;
		$object_duplicated = Db::getInstance()->getRow($sql);
		if ($object_duplicated)
		{
			$sql = 'DELETE FROM `'._DB_PREFIX_.'appagebuilder_profiles` WHERE id_appagebuilder_profiles='.$id;
			Db::getInstance()->execute($sql);
			$sql = 'DELETE FROM `'._DB_PREFIX_.'appagebuilder_profiles_shop` WHERE id_appagebuilder_profiles='.$id;
			Db::getInstance()->execute($sql);
			return $object_duplicated;
		}
		return array();
	}
	public function getPositionsForProfile($id_positions)
	{
		if ($id_positions)
		{
			$sql = 'SELECT * FROM `'._DB_PREFIX_.'appagebuilder_positions` WHERE id_appagebuilder_positions IN('.$id_positions.')';
			return Db::getInstance()->executes($sql);
		}
		return array();
	}
}