<?php
/**
* 2007-2015 Apollotheme
*
* NOTICE OF LICENSE
*
* ApPageBuilder is module help you can build content for your shop
*
* DISCLAIMER
*
*  @Module Name: AP Page Builder
*  @author    Apollotheme <apollotheme@gmail.com>
*  @copyright 2007-2015 Apollotheme
*  @license   http://apollotheme.com - prestashop template provider
*/

class ApCategoryImage extends ApShortCodeBase
{
	public $name = 'ApCategoryImage';
	public $for_module = 'manage';
	public $module_name = 'appagebuilder';
	public function getInfo()
	{
		return array('label' => $this->l('Images of categories'),
					'position' => 5,
					'desc' => $this->l('Choosing images for categories'),
					'icon_class' => 'icon-picture',
					'tag' => 'content');
	}
	public function getConfigList()
	{
		$root = Category::getRootCategory();
		$selected_cat = array();
		$selected_cates = '';
		$selected_images = '';
		$image_path = 'themes'.DS._THEME_NAME_.DS.'img'.DS.'modules'.DS;
		$image_list = $this->getImages($image_path);
		if (Tools::getIsset('categorybox'))
		{
			$category_box = Tools::getValue('categorybox');
			$selected_cat = explode(',', $category_box);
		}
		if (Tools::getIsset('category_img'))
			$selected_images = str_replace($this->str_search, $this->str_relace_html, Tools::getValue('category_img'));
		if (Tools::getIsset('selected_cates'))
			$selected_cates = Tools::getValue('selected_cates');
		$tree = new HelperTreeCategories('categorybox', 'All Categories');
		$tree->setRootCategory($root->id)->setUseCheckBox(true)->setSelectedCategories($selected_cat)->setInputName('categorybox');
		$orderby = array(
			array(
				'order' => 'position',
				'name' => $this->l('Position')
			),
			array(
				'order' => 'depth',
				'name' => $this->l('Depth')
			),
			array(
				'order' => 'name',
				'name' => $this->l('Name')
			)
		);
		$showicons = array(
			array(
				'show' => '1',
				'name' => $this->l('Yes')
			),
			array(
				'show' => '2',
				'name' => $this->l('Level 1 categories')
			),
			array(
				'show' => '0',
				'name' => $this->l('No')
			)
		);
		$path_image = __PS_BASE_URI__.'themes/'.Context::getContext()->shop->getTheme().'/img/modules/'.$this->module_name.'/icon/';
		Context::getContext()->smarty->assign('path_image', $path_image);
		$href = Context::getContext()->link->getAdminLink('AdminApPageBuilderImages').'&imgDir=icon&is_ajax=true';
		$image_uploader = new HelperImageUploader('file');
		$image_uploader->setSavePath(_PS_ALL_THEMES_DIR_.Context::getContext()->shop->getTheme().'/img/modules/'.$this->module_name.'/icon/');
		$image_uploader->setMultiple(true)->setUseAjax(true)->setUrl(
			Context::getContext()->link->getAdminLink('AdminApPageBuilderImages').'&ajax=1&action=ajaxProcessAddImage&imgDir=icon');
		$tree_html = $tree->render();
		$inputs = array(
			array(
				'type' => 'text',
				'name' => 'title',
				'label' => $this->l('Title'),
				'desc' => $this->l('Auto hide if leave it blank'),
				'lang' => 'true',
				'default' => ''
			),
			array(
				'type' => 'img_cat',
				'name' => 'img_cat',
				'imageList' => $image_list,
				'selected_images' => $selected_images,
				'selected_cates' => $selected_cates,
				'lang' => true,
				'tree' => $tree_html,
				'href_image' => $href,
				'path_image' => $path_image,
				'default' => '',
			),
			array(
				'type' => 'text',
				'label' => $this->l('Depth'),
				'name' => 'cate_depth',
				'default'=> '1',
			),
			array(
				'type' => 'select',
				'label' => $this->l('Order By:'),
				'name' => 'orderby',
				'default' => 'position',
				'options' => array(
					'query' => $orderby,
					'id' => 'order',
					'name' => 'name'
				)
			),
			array(
				'type' => 'select',
				'label' => $this->l('Show icons:'),
				'name' => 'showicons',
				'default' => '1',
				'options' => array(
					'query' => $showicons,
					'id' => 'show',
					'name' => 'name'
				)
			),
			array(
				'type' => 'text',
				'label' => $this->l('Limit'),
				'name' => 'limit',
				'default'=> '5',
			),
			array(
				'type' => 'hidden',
				'name' => 'id_root',
				'default'=> '2',
			),
			array(
				'type' => 'hidden',
				'name' => 'id_lang',
				'default'=> '1',
			)
		);
		return $inputs;
	}
	public function prepareFontContent($assign, $module = null)
	{
		$form_atts = $assign['formAtts'];
		$images = array();
		if (isset($form_atts['category_img']) && $form_atts['category_img'])
		{
			$selected_images = str_replace($this->str_search, $this->str_relace_html, $form_atts['category_img']);
			$images = Tools::jsonDecode($selected_images, true);
		}
		$sql_filter = '';
		$sql_sort = '';
		if (isset($form_atts['orderby']) && $form_atts['orderby'])
		{
			if ($form_atts['orderby'] == 'depth')
				$sql_sort = ' ORDER BY c.`level_depth` ASC';
			if ($form_atts['orderby'] == 'position')
				$sql_sort = ' ORDER BY c.`level_depth` ASC, category_shop.`position` ASC';
			if ($form_atts['orderby'] == 'name')
				$sql_sort = ' ORDER BY c.`level_depth` ASC, cl.`name` ASC';
		}
		$catids = (isset($form_atts['categorybox']) && $form_atts['categorybox']) ? ($form_atts['categorybox']) : '';
		$catids = explode(',', $catids);
		$result = array();
		foreach ($catids as $cate_id)
			if ($cate_id && Validate::isInt($cate_id))
			{
				if (isset($form_atts['cate_depth']) && ($form_atts['cate_depth'] || $form_atts['cate_depth'] == '0'))
					$sql_filter = ' AND c.`level_depth` <= '.(int)$form_atts['cate_depth'].' + (select c.`level_depth` from `'
						._DB_PREFIX_.'category` c where c.id_category ='.$cate_id.')';
				$result_cate = $this->getNestedCategories(
							$images, $cate_id, Context::getContext()->language->id, true, null, true, $sql_filter, $sql_sort);
				$result[] = $result_cate;
			}
		$assign['categories'] = $result;
		$assign['type'] = 'category_image';
		return $assign;
	}
	public function getImages($image_folder)
	{
		$module = $this->module_name.DS;
		$path_module = $this->module_name.DS.'icon'.DS;
		$protocol = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) ? 'https://' : 'http://';
		$url = Tools::htmlentitiesutf8($protocol.$_SERVER['HTTP_HOST'].__PS_BASE_URI__);
		$path = _PS_ROOT_DIR_.DS.$image_folder;
		$path = str_replace( '//', '/', $path );
		$oimages  = array();
		if (is_dir($path.$module) && is_dir($path.$path_module))
		{
			$images = glob($path.$path_module.'*.*');
			$exts = array('jpg','gif','png');
			foreach ($images as $key => $image)
			{
				$ext = Tools::substr($image, Tools::strlen($image) - 3, Tools::strlen($image));
				if (in_array(Tools::strtolower($ext), $exts))
				{
					$i = str_replace('\\', '/', $image_folder.$path_module.basename($image));
					$i = str_replace('//', '/', $i );
					$aimage = array();
					$aimage['path'] = $url.$i;
					$aimage['name'] = basename($image);
					$oimages[] = $aimage;
				}
			}
		}
		else
		{
			if (!is_dir($path.$module))
				mkdir($path.$module);
			if (!is_dir($path.$path_module))
				mkdir($path.$path_module);
		}
		return $oimages;
	}
	public function getNestedCategories($images, $root_category = null, $id_lang = false, $active = true, $groups = null,
		$use_shop_restriction = true, $sql_filter = '', $sql_sort = '', $sql_limit = '')
	{
		$protocol = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) ? 'https://' : 'http://';
		$url = Tools::htmlentitiesutf8($protocol.$_SERVER['HTTP_HOST'].__PS_BASE_URI__);
		$image_path = 'themes/'._THEME_NAME_.'/img/modules/'.$this->module_name.'/icon/';
		if (isset($root_category) && !Validate::isInt($root_category))
			die(Tools::displayError());
		if (!Validate::isBool($active))
			die(Tools::displayError());
		if (isset($groups) && Group::isFeatureActive() && !is_array($groups))
			$groups = (array)$groups;
		$cache_id = 'Category::getNestedCategories_'.md5((int)$root_category.(int)$id_lang.(int)$active.(int)$active
			.(isset($groups) && Group::isFeatureActive() ? implode('', $groups) : ''));
		if (!Cache::isStored($cache_id))
		{
			$sql = '
				SELECT c.*, cl.*
				FROM `'._DB_PREFIX_.'category` c'
				.($use_shop_restriction ? Shop::addSqlAssociation('category', 'c') : '').'
				LEFT JOIN `'._DB_PREFIX_.'category_lang` cl ON c.`id_category` = cl.`id_category`'.Shop::addSqlRestrictionOnLang('cl')
				.(isset($groups) && Group::isFeatureActive() ? 'LEFT JOIN `'._DB_PREFIX_.'category_group` cg ON c.`id_category` = cg.`id_category`' : '')
				.(isset($root_category) ? 'RIGHT JOIN `'._DB_PREFIX_.'category` c2 ON c2.`id_category` = '
				.(int)$root_category.' AND c.`nleft` >= c2.`nleft` AND c.`nright` <= c2.`nright`' : '')
				.' WHERE 1 '.$sql_filter.($id_lang ? ' AND `id_lang` = '.(int)$id_lang : '')
				.($active ? ' AND c.`active` = 1' : '')
				.(isset($groups) && Group::isFeatureActive() ? ' AND cg.`id_group` IN ('.implode(',', $groups).')' : '')
				.(!$id_lang || (isset($groups) && Group::isFeatureActive()) ? ' GROUP BY c.`id_category`' : '')
				.($sql_sort != '' ? $sql_sort : ' ORDER BY c.`level_depth` ASC')
				.($sql_sort == '' && $use_shop_restriction ? ', category_shop.`position` ASC' : '')
				.($sql_limit != '' ? $sql_limit : '');
			// echo ($sql);
			$result = Db::getInstance()->executeS($sql);
			$categories = array();
			$buff = array();
			if (!isset($root_category))
				$root_category = 1;
			foreach ($result as $row)
			{
				//add image to a category
				if (array_key_exists($row['id_category'], $images))
					$row['image'] = $url.$image_path.$images[$row['id_category']];
				$current = &$buff[$row['id_category']];
				$current = $row;
				if ($row['id_category'] == $root_category)
					$categories[$row['id_category']] = &$current;
				else
					$buff[$row['id_parent']]['children'][$row['id_category']] = &$current;
			}
			Cache::store($cache_id, $categories);
		}
		return Cache::retrieve($cache_id);
	}
}