<?php
/**
* 2007-2015 Apollotheme
*
* NOTICE OF LICENSE
*
* ApPageBuilder is module help you can build content for your shop
*
* DISCLAIMER
*
*  @Module Name: AP Page Builder
*  @author    Apollotheme <apollotheme@gmail.com>
*  @copyright 2007-2015 Apollotheme
*  @license   http://apollotheme.com - prestashop template provider
*/

require_once(_PS_MODULE_DIR_.'appagebuilder/classes/ApPageBuilderHookModel.php');
class ApRow extends ApShortCodeBase
{
	public $name = 'ApRow';
	public $for_module = 'manage';
	public $show_upload = '1';
	public $atribute = array('el_class' => '');
	public function getInfo()
	{
		return array('label' => $this->l('Row'), 'position' => 1,
			'desc' => $this->l('Each row can have one or more Column'),
			'tag' => 'content structure');
	}
	public function getConfigList()
	{
		$input = array(
			array(
				'type' => 'tabConfig',
				'name' => 'title',
				'values' => array(
					'aprow_general' => $this->l('General'),
					'aprow_style' => $this->l('Style'),
					'aprow_background' => $this->l('Background'),
					'aprow_animation' => $this->l('Animation'),
					'aprow_exceptions' => $this->l('Exceptions'))
			),
			array(
				'type' => 'text',
				'name' => 'title',
				'label' => $this->l('Title'),
				'desc' => $this->l('Auto hide if leave it blank'),
				'lang' => 'true',
				'form_group_class' => 'aprow_general',
				'default' => ''
			),
			array(
				'type' => 'text',
				'name' => 'id',
				'label' => $this->l('ID'),
				'form_group_class' => 'aprow_general',
				'desc' => $this->l('Use for css and javascript'),
				'default' => ''
			),
			array(
				'type' => 'text',
				'name' => 'container',
				'label' => $this->l('Class container'),
				'form_group_class' => 'aprow_general',
				'desc' =>  $this->getDescriptionContainerInput(),
				'default' => ''
			),
			array(
				'type' => 'ApRowclass',
				'name' => 'class',
				'form_group_class' => 'aprow_general',
				'default' => 'row'
			),
			array(
				'type' => 'text',
				'name' => 'min_height',
				'label' => $this->l('Minimum height'),
				'desc' => $this->l('You can use pixels : 10px or percents : 10%.'),
				'default' => '',
				'form_group_class' => 'aprow_style',
			),
			array(
				'type' => 'text',
				'label' => $this->l('Margin Top'),
				'name' => 'margin_top',
				'desc' => $this->l('You can use pixels :10px or percents : 10%.'),
				'default' => '',
				'form_group_class' => 'aprow_style',
			),
			array(
				'type' => 'text',
				'label' => $this->l('Margin Bottom'),
				'name' => 'margin_bottom',
				'desc' => $this->l('You can use pixels :10px or percents : 10%.'),
				'default' => '',
				'form_group_class' => 'aprow_style',
			),
			array(
				'type' => 'text',
				'label' => $this->l('Padding Top'),
				'name' => 'padding_top',
				'desc' => $this->l('You can use pixels :10px or percents : 10%.'),
				'default' => '',
				'form_group_class' => 'aprow_style',
			),
			array(
				'type' => 'text',
				'label' => $this->l('Padding Bottom'),
				'name' => 'padding_bottom',
				'desc' => $this->l('You can use pixels : 10px or percents : 10%.'),
				'default' => '',
				'form_group_class' => 'aprow_style',
			),
                        array(
				'type' => 'select',
				'label' => $this->l('Background Config'),
				'name' => 'bg_config',
				'default' => 'boxed',
				'options' => array(
					'query' => array(
						array(
							'id' => 'fullwidth',
							'name' => $this->l('Full width'),
						),
						array(
							'id' => 'boxed',
							'name' => $this->l('Boxed'),
						),
                                                array(
							'id' => 'none',
							'name' => $this->l('None'),
						),
					),
					'id' => 'id',
					'name' => 'name'
				),
				'form_group_class' => 'aprow_background',
			),
                        array(
				'type' => 'select',
				'label' => $this->l('Background Type'),
				'name' => 'bg_type',
				'class' => 'form-action',
				'options' => array(
					'query' => array(
						array(
							'id' => 'normal',
							'name' => $this->l('Normal'),
						),
						array(
							'id' => 'fixed',
							'name' => $this->l('Fixed'),
						),
						array(
							'id' => 'parallax',
							'name' => $this->l('Parallax'),
						),
						array(
							'id' => 'mouseparallax',
							'name' => $this->l('Mouse Parallax'),
						),
//						array(
//							'id' => 'video_youtube',
//							'name' => $this->l('Video Youtube'),
//						),
//                                                array(
//							'id' => 'video_vimeo',
//							'name' => $this->l('Vimeo video'),
//						),
//                                                array(
//							'id' => 'video_html5',
//							'name' => $this->l('HTML5'),
//						)
					),
					'id' => 'id',
					'name' => 'name'
				),
				'form_group_class' => 'aprow_background',
			),
			array(
				'type' => 'color',
				'label' => $this->l('Background color'),
				'name' => 'bg_color',
				'default' => '',
				'form_group_class' => 'aprow_background bg_type_sub bg_type-normal bg_type-fixed bg_type-parallax bg_type-mouseparallax',
			),
			array(
				'type' => 'html',
				'html_content' => '<script type="text/javascript" src="'._PS_JS_DIR_.'jquery/plugins/jquery.colorpicker.js"></script>',
			),
			array(
				'type' => 'bg_img',
				'label' => $this->l('Background image'),
				'name' => 'bg_img',
                                'img_link' => _THEME_IMG_DIR_.'modules/'.$this->module_name.'/images/',
				'default' => '',
				'form_group_class' => 'aprow_background bg_type_sub bg_type-normal bg_type-fixed bg_type-parallax bg_type-mouseparallax',
			),
			array(
				'type' => 'text',
				'label' => $this->l('Background position'),
				'name' => 'bg_position',
                                'desc' => $this->l('Set CSS value for the background image position. (Ex: center top, right bottom, 50% 50%, 100px 200px,..)'),
				'form_group_class' => 'aprow_background bg_type_sub bg_type-normal bg_type-fixed bg_type-parallax',
			),
			array(
				'type' => 'select',
				'label' => $this->l('Background repeat'),
				'name' => 'bg_repeat',
				'options' => array(
					'query' => array(
						array(
							'id' => 'no-repeat',
							'name' => $this->l('No repeat'),
						),
						array(
							'id' => 'repeat',
							'name' => $this->l('Repeat All'),
						),
						array(
							'id' => 'repeat-x',
							'name' => $this->l('repeat horizontally only'),
						),
						array(
							'id' => 'repeat-y',
							'name' => $this->l('repeat vertically only'),
						)
					),
					'id' => 'id',
					'name' => 'name'
				),
                                'form_group_class' => 'aprow_background bg_type_sub bg_type-normal bg_type-fixed bg_type-parallax bg_type-mouseparallax',
			),
			array(
				'type' => 'text',
				'label' => $this->l('Parallax speed'),
				'name' => 'parallax_speed',
				'default' => '0.1',
                                'desc' => $this->l('Set the background speed, this is relative to the natural scroll speed (Ex: 0, 0.5, 1, 2).'),
				'form_group_class' => 'aprow_background bg_type_sub bg_type-parallax',
			),
                        array(
				'type' => 'select',
				'label' => $this->l('Parallax axis'),
                                'desc'  => $this->l('Select axis effect for this background.'),
				'name' => 'parallax_axis',
                                'desc'  => $this->l('Select axis effect for this background.'),
				'options' => array(
					'query' => array(
						array(
							'id' => 'both',
							'name' => $this->l('Both'),
						),
						array(
							'id' => 'axis-x',
							'name' => $this->l('Axis X (horizontally)'),
						),
						array(
							'id' => 'axis-y',
							'name' => $this->l('Axis Y (vertically)'),
						)
					),
					'id' => 'id',
					'name' => 'name'
				),
                                'form_group_class' => 'aprow_background bg_type_sub bg_type-mouseparallax',
			),
                        array(
				'type' => 'text',
				'label' => $this->l('Parallax strength'),
				'name' => 'parallax_strength',
				'default' => '0.5',
                                'desc' => $this->l('Set the background strength, this is relative to the natural mouse speed (Ex: 0, 0.5, 1, 2).'),
				'form_group_class' => 'aprow_background bg_type_sub bg_type-mouseparallax',
			),
                        array(
				'type' => 'text',
				'label' => $this->l('Parallax rid'),
				'name' => 'parallax_rid',
				'default' => '0.5',
				'form_group_class' => 'aprow_background bg_type_sub bg_type-mouseparallax',
			),
                        array(
				'type' => 'text',
				'label' => $this->l('Parallax horizontal offsets'),
				'name' => 'parallax_hoffsets',
				'default' => '0.1',
                                'desc' => $this->l('Set the global alignment horizontal offset'),
				'form_group_class' => 'aprow_background bg_type_sub bg_type-parallax',
			),
                        array(
				'type' => 'text',
				'label' => $this->l('Parallax vertical speed'),
				'name' => 'parallax_voffsets',
				'default' => '0.1',
                                'desc' => $this->l('Set the global alignment vertical offset'),
				'form_group_class' => 'aprow_background bg_type_sub bg_type-parallax',
			),
                        
			array(
				'type' => 'text',
				'label' => $this->l('Video background'),
				'name' => 'video_link',
				'default' => '',
				'desc' => $this->l('Put video youtube link or vimeo'),
				'form_group_class' => 'aprow_background bg_type_sub bg_type-video_html5',
			),
                        array(
				'type' => 'text',
				'label' => $this->l('Video ID'),
				'name' => 'video_id',
				'default' => '',
				'desc' => $this->l('Put video ID of youtube link or vimeo'),
				'form_group_class' => 'aprow_background bg_type_sub bg_type-video_youtube bg_type-video_vimeo',
			),
			array(
				'type' => 'select',
				'label' => $this->l('Animations'),
				'name' => 'animation',
				'class' => 'animation-select',
				'options' => array(
						'optiongroup' => array(
								'label' => 'name',
								'query' => ApPageSetting::getAnimations(),
						),
						'options' => array(
								'id' => 'id',
								'name' => 'name',
								'query' => 'query',
						),
				),
				'form_group_class' => 'aprow_animation',
			),
			array(
				'type' => 'html',
				'html_content' => '<div id="animationSandbox">Apollotheme.com</div>',
				'form_group_class' => 'aprow_animation animate_sub',
			),
			array(
				'type' => 'text',
				'label' => $this->l('Delay'),
				'name' => 'animation_delay',
				'default' => '2',
				'suffix' => 's',
				'class' => 'fixed-width-xs',
				'form_group_class' => 'aprow_animation animate_sub',
			),
			array(
				'type' => 'select',
				'label' => $this->l('Specific Controller'),
				'name' => 'specific_type',
				'class' => 'form-action',
				'options' => array(
					'query' => array(
						array(
							'id' => 'all',
							'name' => $this->l('Show on all Page Controller'),
						),
						array(
							'id' => 'index',
							'name' => $this->l('Show on only Index'),
						),
						array(
							'id' => 'category',
							'name' => $this->l('Show on only Category'),
						),
						array(
							'id' => 'product',
							'name' => $this->l('Show on only Product'),
						),
						array(
							'id' => 'cms',
							'name' => $this->l('Show on only CMS'),
						)
					),
					'id' => 'id',
					'name' => 'name'
				),
				'form_group_class' => 'aprow_exceptions',
				'default'=>'all'
			),
			array(
				'type' => 'text',
				'label' => $this->l('Controller ID'),
				'name' => 'controller_id',
				'desc' => $this->l('Example: 1,2,3'),
				'default' => '',
				'form_group_class' => 'aprow_exceptions specific_type_sub specific_type-category specific_type-product specific_type-cms',
			),
			array(
				'type' => 'apExceptions',
				'name' => 'controller_pages',
				'form_group_class' => 'aprow_exceptions specific_type_sub specific_type-all',
			),
		);
		return $input;
	}
	
	public function prepareFontContent($assign, $module = null)
	{
                $formAtts = $assign['formAtts'];
                
                //process back-ground
                $formAtts['bg_class'] = "";
                $formAtts['bg_data'] = "";
                $formAtts['parallax'] = "";
                $formAtts['bg_video'] = "";
                
                //1. set class
                if(isset($formAtts['bg_config']) && $formAtts['bg_config']){
                    $formAtts['bg_class'] = "has-bg";
                    //video
                    if(isset($formAtts['bg_type']) && ($formAtts['bg_type'] == "video_youtube" || $formAtts['bg_type'] == "video_youtube" || $formAtts['bg_type'] == "video_youtube")){
                        $formAtts['bg_video'] = $this->getBgStyleVideo($formAtts);
                    }else{
                    
                        if($formAtts['bg_config'] == "boxed"){
                            $formAtts['bg_class'] .= " bg-boxed";
                        }else{
                            if(isset($formAtts['container']) && $formAtts['container']){
                                $formAtts['bg_class'] .= " bg-fullwidth-container";
                            }else{
                                $formAtts['id']  = (isset($formAtts['id']) && $formAtts['id']!="")?$formAtts["id"]:$formAtts["form_id"];
                                $formAtts['bg_class'] .= " bg-fullwidth";
                            }
                        }
                        if(isset($formAtts['bg_color']) && $formAtts['bg_color']){
                            $formAtts['bg_data'] .= " ".$formAtts['bg_color'];
                        }
                        if(isset($formAtts['bg_img']) && $formAtts['bg_img']){
                            if (strpos($formAtts['bg_img'],'/') == false) {
                                $formAtts['bg_img'] = _THEME_IMG_DIR_.'modules/'.$this->module_name.'/images/'.$formAtts['bg_img'];
                            }
                            $formAtts['bg_data'] .= " url(".$formAtts['bg_img'].")";
                        }
                        if(isset($formAtts['bg_type']) && $formAtts['bg_type'] == "fixed"){
                            $formAtts['bg_data'] .= " fixed";
                        }
                        if($formAtts['bg_repeat']){
                            $formAtts['bg_data'] .= " ".$formAtts['bg_repeat'];
                        }
                        if(isset($formAtts['bg_position']) && $formAtts['bg_position']){
                            $formAtts['bg_data'] .= " ".$formAtts['bg_position'];
                        }
                        //config for background style - stela - stela
                        if(isset($formAtts['bg_type']) && $formAtts['bg_type'] == "parallax"){
                            $formAtts['bg_class'] .= " bg-parallax";
                            $hoffset = (isset($formAtts['parallax_hoffsets']) && $formAtts['parallax_hoffsets'])?$formAtts['parallax_hoffsets']:"40";
                            $voffset = (isset($formAtts['parallax_voffsets']) && $formAtts['parallax_voffsets'])?$formAtts['parallax_voffsets']:"150";
                            $bratio = (isset($formAtts['parallax_speed']) && $formAtts['parallax_speed'])?$formAtts['parallax_speed']:"0.5";

                            $formAtts['id']  = (isset($formAtts['id']) && $formAtts['id']!="")?$formAtts["id"]:$formAtts["form_id"];

                            $formAtts['parallax'] = 'data-stellar-horizontal-offset="'.$hoffset.'" data-stellar-vertical-offset="'.$voffset.'" data-stellar-background-ratio="'.$bratio.'"';
                        }

                        if(isset($formAtts['bg_type']) && $formAtts['bg_type'] == "mouseparallax"){
                            $strength = (isset($formAtts['parallax_strength']) && $formAtts['parallax_strength'])?$formAtts['parallax_strength']:"40";
                            $axis = (isset($formAtts['parallax_axis']) && $formAtts['parallax_axis'])?$formAtts['parallax_axis']:"both";
                            $rid = (isset($formAtts['parallax_rid']) && $formAtts['parallax_rid'])?$formAtts['parallax_rid']:"0.5";

                            $formAtts['id']  = $formAtts["form_id"];

                            $formAtts['parallax'] = 'data-mouse-parallax-strength="'.$strength.'" data-mouse-parallax-axis="'.$axis.'" data-mouse-parallax-rid="'.$rid.'"';
                        }
                    
                    }
                }
                
		if(isset($formAtts['bg_img']) && isset($formAtts['img_link'])){
			
			if($formAtts['bg_img'] == '' && $formAtts['img_link'] != ''){
                            $formAtts['bg_img'] = $formAtts['img_link'];
			}
		}
		
		if( !isset($formAtts['animation']) || $formAtts['animation'] == 'none')
		{
			$formAtts['animation'] = 'none';
			$formAtts['animation_delay'] = '';
		}
		elseif( $formAtts['animation'] != 'none' && intval($formAtts['animation_delay']) > 0)
		{
			$formAtts['animation_delay'] .= 's';
		}
		elseif( $formAtts['animation'] != 'none' &&  intval($formAtts['animation_delay']) <= 0)
		{
			// Default delay
			$formAtts['animation_delay'] = '1s';
		}
		
		# set style
		$assign['formAtts'] = $formAtts;
		$formAtts['css_style'] = $this->showCSSStyle($assign);
		$assign['formAtts']['css_style'] = $this->showCSSStyle($assign);
		$this->checkFullwidth($assign);

		return $assign;
	}

	public function checkFullwidth(&$assign)
	{
		$page_name = Context::getContext()->smarty->tpl_vars['page_name']->value;
		$hook_name = ApShortCodesBuilder::$hook_name;
		
		$hook_model = new ApPageBuilderHookModel();
		$hook_model->create();
		

		if ($page_name == 'index')
			$hooks = $hook_model->fullwidth_index_hook;
		else
			$hooks = $hook_model->fullwidth_other_hook;

		if (isset($hooks[$hook_name]) && $hooks[$hook_name] == ApPageSetting::hook_fulwidth_indexpage)
		{
			$assign['formAtts']['container_remove'] = '0';
		}
		else
		{
			# remove container class - BEGIN
			if (isset($assign['formAtts']['container']))
			{
				$str_search = array('/\bcontainer\b/');
				$str_replace = array('');
				$str_subject = $assign['formAtts']['container'];

				$assign['formAtts']['container'] = preg_replace($str_search, $str_replace, $str_subject);
				$assign['formAtts']['container_remove'] = '1';
			}
			# remove container class - END
		}
	}

	public function getHookLayout(){
		$hook_name = Tools::getValue('hook_name');

		$hook_model = new ApPageBuilderHookModel();
		$hook_model->create();

		return $hook_model->fullwidthHook($hook_name, 'index');
	}
	
	/*
	 * Live 
	 * not follow in database
	 */
	public function getRowLayOut($hook_layout)
	{
		$row_layout = ApPageSetting::row_boxed;
		if($hook_layout == ApPageSetting::hook_fulwidth_indexpage){
			$row_container = Tools::getValue('container');
			if( !preg_match('/\bcontainer\b/',$row_container) ) {
				$row_layout = ApPageSetting::row_fulwidth_indexpage;
			}
		}
			
		return $row_layout;
	}
	
	public function getDescriptionContainerInput()
	{
		$hook_layout = $this->getHookLayout();
		$row_layout = $this->getRowLayOut($hook_layout);
		
		$id_profile = Tools::getValue('id_appagebuilder_profiles');
		$url_profile_edit = Context::getContext()->link->getAdminLink('AdminApPageBuilderProfiles').
				'&id_appagebuilder_profiles='.$id_profile.'&updateappagebuilder_profiles';
		$link = '<a href="'.$url_profile_edit.'" target="blank">edit profile</a>';
		
		$hook_name = Tools::getValue('hook_name');
		
		$row_layout_text = 'Boxed';
		if($row_layout){
			$row_layout_text = 'Fullwidth';
		}
		
		$row_contain_class = 0;
		$row_container = Tools::getValue('container');
		if( preg_match('/\bcontainer\b/',$row_container) ) {
			$row_contain_class = 1;
		}
		
		
		
		if($row_layout){
			# fullwidth
			$desc = 'Now Layout of Row is <strong>' . $row_layout_text . '</strong>, to change to Boxed :';
			$desc .= '<br />';
			$desc .= '- Typing "container" to above textbox.';
		}else{
			# boxed
			$desc = 'Now Layout of Row is <strong>' . $row_layout_text . '</strong>, to change to Fullwidth :';
			if($row_contain_class){
				$desc .= '<br />';
				$desc .= '- Removing "container" above textbox.';
			}
			if($hook_layout == ApPageSetting::hook_boxed){
				$desc .= '<br />';
				$desc .= '- Going to '.$link.' check option "'.$hook_name.'" hook of "Fullwidth Homepage"';
			}
		}
		return $desc;
	}

	public function showCSSStyle($assign)
	{
		$formAtts = $assign['formAtts'];
		$style = 'style="';
		if( isset($formAtts['bg_config']) && $formAtts['bg_config'] == 'boxed' && isset($formAtts['bg_data']) && $formAtts['bg_data'])
			$style .= 'background:'.$formAtts['bg_data'] . ';';
		if(isset($formAtts['min_height']) && $formAtts['min_height'])
			$style .= 'min-height: ' . $formAtts['min_height'] . ';';
		if(isset($formAtts['margin_top']) && $formAtts['margin_top'])
			$style .= 'margin-top: ' . $formAtts['margin_top'] . ';';
		if(isset($formAtts['margin_bottom']) && $formAtts['margin_bottom'])
			$style .= 'margin-bottom: ' . $formAtts['margin_bottom'] . ';';
		if(isset($formAtts['padding_top']) && $formAtts['padding_top'])
			$style .= 'padding-top: ' . $formAtts['padding_top'] . ';';
		if(isset($formAtts['padding_bottom']) && $formAtts['padding_bottom'])
			$style .= 'padding-bottom: ' . $formAtts['padding_bottom'] . ';';
		$style .='"';
		return $style;
	}
}
?>