<?php
/**
* 2007-2015 Apollotheme
*
* NOTICE OF LICENSE
*
* ApPageBuilder is module help you can build content for your shop
*
* DISCLAIMER
*
*  @Module Name: AP Page Builder
*  @author    Apollotheme <apollotheme@gmail.com>
*  @copyright 2007-2015 Apollotheme
*  @license   http://apollotheme.com - prestashop template provider
*/

class ApVideo extends ApShortCodeBase
{
	public $name = 'ApVideo';
	public $for_module = 'manage';
	public function getInfo()
	{
		return array('label' => $this->l('Video'),
					'position' => 5,
					'desc' => $this->l('Embed video box'),
					'icon_class' => 'icon-facetime-video',
					'tag' => 'social');
	}
	public function getConfigList()
	{
		$inputs = array(
			array(
				'type' => 'text',
				'name' => 'title',
				'label' => $this->l('Title'),
				'desc'  => $this->l('Auto hide if leave it blank'),
				'lang'  => 'true',
				'form_group_class' => 'aprow_general',
				'default' => ''
			),
			array(
				'type' => 'textarea',
				'label' => $this->l('Code'),
				'name' => 'content_html',
				'cols' => 40,
				'rows' => 10,
				'value' => true,
				'default'=> '',
				'desc' => 'Example embed video: "&ltdiv class="embed-responsive"&gt&ltiframe src="https://www.youtube.com/embed/iZoR21juRzs" 
						frameborder="0" allowfullscreen&gt&lt/iframe&gt&lt/div&gt"',
				'autoload_rte' => false,
			),
			array(
				'type' => 'select',
				'label' => $this->l('Align'),
				'name' => 'align',
					'options' => array('query' => array(
						array('id' => 'left', 'name' => $this->l('Left')),
						array('id' => 'center', 'name' => $this->l('Center')),
						array('id' => 'right', 'name' => $this->l('Right'))
					),
					'id' => 'id',
					'name' => 'name'
				),
				'default' => 'center',
			)
		);
		return $inputs;
	}
	public function prepareFontContent($assign, $module = null)
	{
		// Get all store of shop
		$base_model = new ApPageBuilderModel();
		$data_list = $base_model->getAllStoreByShop();
		$form_atts = $assign['formAtts'];
		$not_all = (isset($form_atts['display_store']) && $form_atts['display_store']);
		$store_ids = explode(',', (isset($form_atts['store']) && $form_atts['store']) ? $form_atts['store'] : '');
		$markers = array();
		if ($not_all)
			foreach ($store_ids as $id)
				foreach ($data_list as $store)
					if ($id == $store['id_store'])
					{
						$markers[] = $store;
						break;
					}
		else
			$markers = $data_list;
		$assign['markers'] = Tools::jsonEncode($markers);
		//echo ($notAll ? 'not all' : 'all');
		//echo '<pre>'; print_r($assign); die();
		return $assign;
	}
}