<?php

/*
 *  @Module Name: AP Page Builder
 *  @Website: apollotheme.com - prestashop template provider
 *  @author Apollotheme <apollotheme@gmail.com>
 *  @copyright  2007-2015 Apollotheme
 *  @description: ApPageBuilder is module help you can build content for your shop
 */

if (!class_exists("ApPageSetup")) {

    class ApPageSetup {
        public static function getTabs(){
            return array(
                array(
                    'class_name' => 'AdminApPageBuilderProfiles',
                    'name' => 'Ap Profiles Manage',
                ),
                array(
                    'class_name' => 'AdminApPageBuilderPositions',
                    'name' => 'Ap Positions Manage',
                ),
                array(
                    'class_name' => 'AdminApPageBuilderHome',
                    'name' => 'Ap Hook Builder',
                    'id_parent' => -1,
                ),
                array(
                    'class_name' => 'AdminApPageBuilderProducts',
                    'name' => 'Ap Products List Builder',
                ),
                array(
                    'class_name' => 'AdminApPageBuilderImages',
                    'name' => 'Ap Image Manage',
                    'id_parent' => -1,
                ),
                array(
                    'class_name' => 'AdminApPageBuilderShortcodes',
                    'name' => 'Ap Shortcodes Builder',
                    'id_parent' => -1,
                ),
            );
        }

        public static function install(){
            $res = self::createTables();
            self::installModuleTab();
            return $res;
        }
         
        public static function createTables() {
            if (file_exists(_PS_MODULE_DIR_.'leotempcp')){
                require_once(_PS_MODULE_DIR_.'leotempcp/libs/DataSample.php');

                $sample = new Datasample(1);
                if($sample->processImport('appagebuilder')) return true;
            }
            
            //each shop will have one or more profile
            $res = (bool) Db::getInstance()->execute('
                CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'appagebuilder_profiles` (
                    `id_appagebuilder_profiles` int(11) NOT NULL AUTO_INCREMENT,
                        `name` varchar(255),
                        `profile_key` varchar(255),
                        `page` varchar(255),
                        `params` text,
                        `header` int(11) unsigned NOT NULL,
                        `content` int(11) unsigned NOT NULL,
                        `footer` int(11) unsigned NOT NULL,
                        `product` int(11) unsigned NOT NULL,
                    PRIMARY KEY (`id_appagebuilder_profiles`)
                ) ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=UTF8;
            ');
            
            $res &= Db::getInstance()->execute('
                CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'appagebuilder_profiles_shop` (
                  `id_appagebuilder_profiles` int(11) NOT NULL AUTO_INCREMENT,
                  `id_shop` int(10) unsigned NOT NULL,
                  `active` TINYINT(1),
                  PRIMARY KEY (`id_appagebuilder_profiles`, `id_shop`)
                ) ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=UTF8;
            ');
            
            //we can create product item for each shop
            $res &= (bool) Db::getInstance()->execute('
                CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'appagebuilder_products` (
                    `id_appagebuilder_products` int(11) NOT NULL AUTO_INCREMENT,
                        `plist_key` varchar(255),
                        `name` varchar(255),
                        `class` varchar(255),
                        `params` text,
                        `type` TINYINT(1),
                    PRIMARY KEY (`id_appagebuilder_products`)
                ) ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=UTF8;
            ');
            
            $res &= Db::getInstance()->execute('
                CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'appagebuilder_products_shop` (
                  `id_appagebuilder_products` int(11) NOT NULL AUTO_INCREMENT,
                  `id_shop` int(10) unsigned NOT NULL,
                  `active` TINYINT(1),
                  PRIMARY KEY (`id_appagebuilder_products`, `id_shop`)
                ) ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=UTF8;
            ');
            
            $res &= (bool) Db::getInstance()->execute('
                CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'appagebuilder` (
                    `id_appagebuilder` int(11) NOT NULL AUTO_INCREMENT,
                        `id_appagebuilder_positions` int(11) NOT NULL,
                        `hook_name` varchar(255),
                    PRIMARY KEY (`id_appagebuilder`)
                ) ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=UTF8;
            ');

            
            $res &= Db::getInstance()->execute('
                CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'appagebuilder_shop` (
                  `id_appagebuilder` int(11) NOT NULL AUTO_INCREMENT,
                  `id_shop` int(10) unsigned NOT NULL,
                  PRIMARY KEY (`id_appagebuilder`, `id_shop`)
                ) ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=UTF8;
            ');

            $res &= Db::getInstance()->execute('
                CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'appagebuilder_lang` (
                   `id_appagebuilder` int(11) NOT NULL AUTO_INCREMENT,
                   `id_lang` int(10) unsigned NOT NULL,
                   `params` text,
                   PRIMARY KEY (`id_appagebuilder`, `id_lang`)
                ) ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=UTF8;
                
            ');

            $res &= Db::getInstance()->execute('
                CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'appagebuilder_positions` (
                    `id_appagebuilder_positions` int(11) NOT NULL AUTO_INCREMENT,
                    `name` varchar(255) NOT NULL,
                    `position` varchar(255) NOT NULL,
                    `position_key` varchar(255) NOT NULL,
                    `params` text,
                    PRIMARY KEY (`id_appagebuilder_positions`)
                ) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=UTF8;
            ');
            
            $res &= Db::getInstance()->execute('
                CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'appagebuilder_positions_shop` (
                  `id_appagebuilder_positions` int(11) NOT NULL AUTO_INCREMENT,
                  `id_shop` int(10) unsigned NOT NULL,
                  PRIMARY KEY (`id_appagebuilder_positions`, `id_shop`)
                ) ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=UTF8;
            ');
            return $res;
        }
        
        public static function updatePositionShop($id_shop){
            Db::getInstance()->execute('
                CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'appagebuilder_positions_shop` (
                  `id_appagebuilder_positions` int(11) NOT NULL AUTO_INCREMENT,
                  `id_shop` int(10) unsigned NOT NULL,
                  PRIMARY KEY (`id_appagebuilder_positions`, `id_shop`)
                ) ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=UTF8;
            ');
            //$proFiles = Db::getInstance()->executes(
            $proFiles = Db::getInstance()->executes('SELECT id_appagebuilder_profiles as id, id_shop FROM `' . _DB_PREFIX_ . 'appagebuilder_profiles_shop`');
            //echo '<pre>';print_r($proFiles);die;
            foreach($proFiles as $pro){
                $proFileModel = new ApPageBuilderProfilesModel($pro['id']);
                
                $sql = 'INSERT INTO `'._DB_PREFIX_.'appagebuilder_positions_shop` (`id_shop`, `id_appagebuilder_positions`)
				VALUES('.(int)$pro['id_shop'].', '.(int)$proFileModel->header.')';
                Db::getInstance()->execute($sql);
                //echo $sql.'<br/>';
                $sql = 'INSERT INTO `'._DB_PREFIX_.'appagebuilder_positions_shop` (`id_shop`, `id_appagebuilder_positions`)
				VALUES('.(int)$pro['id_shop'].', '.(int)$proFileModel->content.')';
                Db::getInstance()->execute($sql);
                //echo $sql.'<br/>';
                $sql = 'INSERT INTO `'._DB_PREFIX_.'appagebuilder_positions_shop` (`id_shop`, `id_appagebuilder_positions`)
				VALUES('.(int)$pro['id_shop'].', '.(int)$proFileModel->footer.')';
                //Db::getInstance()->execute($sql);
                //echo $sql.'<br/>';
                $sql = 'INSERT INTO `'._DB_PREFIX_.'appagebuilder_positions_shop` (`id_shop`, `id_appagebuilder_positions`)
				VALUES('.(int)$pro['id_shop'].', '.(int)$proFileModel->product.')';
                Db::getInstance()->execute($sql);
            }
        }

        public static function installModuleTab() {
            $module = new APPageBuilder();
            //create parent tab
            $newtab = new Tab();     
            $newtab->class_name = 'AdminApPageBuilder';
            $newtab->id_parent = 0;
            $newtab->module = 'appagebuilder';
            foreach(Language::getLanguages() as $l) {
                $newtab->name[$l['id_lang']] = $module->l('Ap PageBuilder');
            }
            if($newtab->save()){
                
                $idParent = $newtab->id;

                foreach (self::getTabs() as $tab){
                    $newtab = new Tab();
                    $newtab->class_name = $tab['class_name'];
                    $newtab->id_parent = isset($tab['id_parent'])?$tab['id_parent']:$idParent;
                    $newtab->module = 'appagebuilder';
                    foreach(Language::getLanguages() as $l) {
                        $newtab->name[$l['id_lang']] = $module->l($tab['name']);
                    }
                    $newtab->save();
                }
            }
        }
        
        public static function uninstall(){
            self::uninstallModuleTab();
            return Db::getInstance()->execute('
                DROP TABLE IF EXISTS `'._DB_PREFIX_.'appagebuilder_profiles`, `'._DB_PREFIX_.'appagebuilder_profiles_shop`, `'.
                    _DB_PREFIX_.'appagebuilder_products`, `'._DB_PREFIX_.'appagebuilder_products_shop` , `'.
                    _DB_PREFIX_.'appagebuilder`, `'._DB_PREFIX_.'appagebuilder_shop`, `'._DB_PREFIX_.'appagebuilder_lang`, `'._DB_PREFIX_.'appagebuilder_positions`, `'._DB_PREFIX_.'appagebuilder_positions_shop`;
            ');
            
        }

        public static function uninstallModuleTab() {
            $id = Tab::getIdFromClassName('AdminApPageBuilder');
            if($id){
                $tab = new Tab($id);
                $tab->delete();
            }
                
            foreach (self::getTabs() as $tab){
                $id = Tab::getIdFromClassName($tab['class_name']);
                if($id){
                    $tab = new Tab($id);
                    $tab->delete();
                }
            }
        }
    }

}
?>