{*
 * @Module Name: AP Page Builder
 * @Website: apollotheme.com - prestashop template provider
 * @author Apollotheme <apollotheme@gmail.com>
 * @copyright  2007-2015 Apollotheme
 * @description: ApPageBuilder is module help you can build content for your shop
 *}
 <!-- @file modules\appagebuilder\views\templates\hook\ApTabs -->
{if !isset($isSubTab)}
<div{if isset($formAtts.id)} id="{$formAtts.id}"{/if}{if isset($formAtts.class)} class="{$formAtts.class}"{/if}>

	{$apLiveEdit}

    {if isset($formAtts.title) && $formAtts.title}
    <h4 class="title_block">{$formAtts.title|rtrim}</h4>
    {/if}
    {if $formAtts.tab_type =='tabs-left'}
        <div class="block_content">
            <ul class="nav nav-tabs col-md-3" role="tablist">
                {foreach from=$subTabContent item=subTab}
                    <li class="{$subTab.css_class} waves-effect waves-light">
                        <a href="#{$subTab.id}" class="{$subTab.form_id}" role="tab" data-toggle="tab">
                            <span>{$subTab.title|escape:'html':'UTF-8'}</span>
                        </a>
                    </li>
                {/foreach}
            </ul>
            <div class="tab-content col-md-9">
                {$apContent}
            </div>
        </div>
    {/if}
    {if $formAtts.tab_type =='tabs-right'}
        <div class="block_content">
            <div class="tab-content col-md-9">
                {$apContent}
            </div>
            <ul class="nav nav-tabs col-md-3" role="tablist">
                {foreach from=$subTabContent item=subTab}
                    <li class="{$subTab.css_class}">
                        <a href="#{$subTab.id}" class="{$subTab.form_id}" role="tab" data-toggle="tab">
                            <span>{$subTab.title|escape:'html':'UTF-8'}</span>
                        </a>
                    </li>
                {/foreach}
            </ul>
        </div>
    {/if}
    {if $formAtts.tab_type =='tabs-below'}
        <div class="block_content">
            <div class="tab-content">
                {$apContent}
            </div>
            <ul class="nav nav-tabs" role="tablist">
                {foreach from=$subTabContent item=subTab}
                    <li class="{$subTab.css_class}">
                        <a href="#{$subTab.id}" class="{$subTab.form_id}" role="tab" data-toggle="tab">
                            <span>{$subTab.title|escape:'html':'UTF-8'}</span>
                        </a>
                    </li>
                {/foreach}
            </ul>
        </div>
    {/if}
    {if $formAtts.tab_type =='tabs-top'}
        <div class="block_content">
            <ul id="tab-default" class="nav nav-tabs" role="tablist" >
                {foreach from=$subTabContent item=subTab}
                    <li class="{$subTab.css_class}">
                        <a href="#{$subTab.id}" class="{$subTab.form_id}" role="tab" data-toggle="tab">
                            <span>{$subTab.title|escape:'html':'UTF-8'}</span>
                        </a>
                    </li>
                {/foreach}
            </ul>
            <div class="nav nav-tabs owl-carousel owl-theme tab-for-top" role="tablist">
                {foreach from=$subTabContent item=subTab}
                    <div class="{$subTab.css_class} item">
                        <a href="#{$subTab.id}" class="{$subTab.form_id}" role="tab" data-toggle="tab">
                            <span>{$subTab.title|escape:'html':'UTF-8'}</span>
                        </a>
                    </div>
                {/foreach}
            </div>
            <div class="tab-content">
                {$apContent}
            </div>
        </div>
    {/if}

	{$apLiveEditEnd}
</div>
<script type="text/javascript">
    $(document).ready(function() {
        $('#{$formAtts.id} .nav a').click(function (e) {
            e.preventDefault();
            $(this).tab('show');
        });

        apTabHref = $('#{$formAtts.id} .nav a:eq({$formAtts.active_tab})').tab('show');
        {if isset($formAtts.fade_effect) && $formAtts.fade_effect}
            $('#{$formAtts.id} .tab-pane').addClass('fade');
            $($(apTabHref).attr('href')).addClass('in');
        {/if}
    });
</script>
{else}
    <div id="{$tabID}" class="tab-pane">
        {$apContent}
    </div>
{/if}
<script>
$(document).ready(function() {
    //$(".tab-for-top").find('.owl-item').removeClass('active');
    $(".tab-for-top").find('.owl-item').first().addClass('active');
    $(".tab-for-top .owl-item").click(function(){
        $('.owl-item',".tab-for-top").removeClass('active');
        $(this).addClass('active');
    });
    var rtl = 'ltr';
    if($('html').hasClass('rtl')){
      rtl = 'rtl';
    }
    $(".tab-for-top").owlCarousel({
            items : 4,
            itemsDesktop : [1199,2],
            itemsDesktopSmall : [992,2],
            itemsTablet : [768,2],
            itemsTabletSmall : [640,2],
            itemsMobile : [479,2],
            singleItem : false,         // chỉ hiện thị 1 item
            itemsScaleUp : false,       // true sẽ hiện thị giãn ảnh nếu diện tích còn thừa, và ẩn nếu độ rộng ko đủ
            slideSpeed : 200,  // tốc độ trôi khi thả chuột, kéo 1 nửa rồi thả ra
            paginationSpeed : 800, // tốc độ next page
            rewindSpeed : 1000, // tốc độ tua lại về first item
            autoPlay : false,   // thời gian show each item
            stopOnHover : true,
            navigation : false,
            navigationText : ["&lsaquo;", "&rsaquo;"],
            rewindNav : true, // enable, disable tua lại về first item
            scrollPerPage : false,

            pagination : false, // show bullist : nut tròn tròn
            paginationNumbers : false, // đổi nut tròn tròn thành số

            responsive :true,
            //responsiveRefreshRate : 200,
            //responsiveBaseWidth : window,

            //baseClass : "owl-carousel",
            //theme : "owl-theme",

            lazyLoad :true,
            lazyFollow : true,  // TRUE : nhảy vào page 7 load ảnh TỪ page 1->7. FALSE : nhảy vào page 7 CHỈ load ảnh page 7
            lazyEffect : "fade",

            autoHeight : true,

            //jsonPath : false,
            //jsonSuccess : false,

            //dragBeforeAnimFinish
            mouseDrag : true,
            touchDrag : true,

            direction : rtl,
            //transitionStyle : "owl_transitionStyle",

            //beforeUpdate : false,
            //afterUpdate : false,
            //beforeInit : false,
            //afterInit : false,
            //beforeMove : false,
            //afterMove : false,
            //afterAction : false,
            //startDragging : false,
            //afterLazyLoad: false
        });
    });
</script>